.proc StartMainMenu
  jsr init_sound
  lda #0
  sta DifficultyMode
  sta DoControllerSwap
  sta EnableNMIDraw
  sta LevelNumber
  sta LevelMapNumber

  lda #0
  sta PPUMASK
  sta PPUSCROLL
  sta PPUSCROLL
  jsr ClearOAM

  lda #<TitleName
  ldx #>TitleName
  jsr CopyFromCHR
  lda #0
  sta 0
  lda #5
  sta 1
  lda #$20
  sta PPUADDR
  lda #$00
  sta PPUADDR
  jsr PKB_unpackblk
  lda #0
  sta PPUSCROLL
  sta PPUSCROLL

  jsr wait_vblank

  lda #BG_ON | OBJ_ON
  sta PPUMASK
  jsr WaitForKey
  jsr wait_vblank

; if the mouse is plugged into player 1's slot, show mouse instructions
  lda mouseEnabled
  beq NoMouse
  lda #$23
  sta PPUADDR
  lda #$87
  sta PPUADDR
  ldx #18
  jsr PrintXSpaces
  lda #$23
  sta PPUADDR
  lda #$67
  sta PPUADDR
  ldx #18
  jsr PrintXSpaces

  lda #$23
  sta PPUADDR
  lda #$67+(3)
  sta PPUADDR
  PrintStringY MouseMenuHelp
  lda #$23
  sta PPUADDR
  lda #$87+(9)
  sta PPUADDR
  ldx #$17
  stx PPUDATA
  inx
  stx PPUDATA
NoMouse:
.endproc
; -- don't put anything here --
.proc StartMainMenu2
  ldy #MainMenuData-MenuData
  jsr RunChoiceMenu
  asl
  tax

  lda retraces
  beq :+
  ora #1
: sta r_seed

  lda MainMenuAddrs+1,x
  pha
  lda MainMenuAddrs+0,x
  pha
  rts
.endproc

MouseMenuHelp:
  .byt "Choose", $07, $08, "Next", 0

PrintXSpaces:
  lda #' '
: sta PPUDATA
  dex
  bne :-
  rts
.proc MainMenuAddrs
  .raddr NewGame
  .raddr NewGameHard
  .raddr HelpAndConfig
  .raddr StartEditorFromMenu
  .raddr ShowCredits
.endproc

MenuData:
.proc MainMenuData
  .byt 5
  .ppuxy 0, 10, 19
  .byt "Normal Game",0
  .ppuxy 0, 10, 20
  .byt "Harder Game",0
  .ppuxy 0, 10, 21
  .byt "Help/Config",0
  .ppuxy 0, 10, 22
  .byt "Level Edit",0
  .ppuxy 0, 10, 23
  .byt "Credits",0
.endproc

.proc RunChoiceMenu ; returns choice selected in A
CurChoice = 2  ; start at 2 and 3 because ReadJoy trashes 0 and 1
NumChoices = 3
  ldx MenuData,y
  stx NumChoices    ; keep number of choices for later
  jsr ClearMenuChoices

NewRow:
  lda #0
  sta PPUSCROLL
  sta PPUSCROLL
  jsr wait_vblank
  iny               ; also skips over zeroes when branched here
  dex
  bmi NoMoreRows
  lda MenuData,y
  sta PPUADDR
  iny
  lda MenuData,y
  sta PPUADDR
  iny
: lda MenuData,y
  beq NewRow
  sta PPUDATA
  iny
  jmp :-
NoMoreRows:
  jsr ClearOAM
  lda #0
  sta CurChoice

ChoiceLoop:
  jsr ReadJoy
  lda mouseEnabled
  beq :+
    lda keynew ; RL...... - ABssudlr
    pha
    asl
    and #KEY_A
    sta keynew
    pla
    asl
    rol
    rol
    rol
    and #KEY_DOWN
    ora keynew
    sta keynew
  :

  lda keynew
  and #KEY_UP
  beq :+
    dec CurChoice
    bpl :+
      lda NumChoices
      sta CurChoice
      dec CurChoice
  :

  lda keynew
  and #KEY_DOWN
  beq :+
    inc CurChoice
    lda CurChoice
    cmp NumChoices
    bcc :+
      lda #0
      sta CurChoice
  :

  lda #10*8-16
  sta OAM_XPOS+(4*0)
  lda CurChoice
  asl
  asl
  asl
  add #19*8-1
  sta OAM_YPOS+(4*0)
  lda #$1c
  sta OAM_TILE+(4*0)
  lda #0
  sta OAM_ATTR+(4*0)

  lda keynew
  and #KEY_A|KEY_START
  bne ChoiceSelected

  jsr wait_vblank
  jmp ChoiceLoop

ChoiceSelected:
  jsr ClearOAM
  lda CurChoice
  rts
.endproc

.proc ClearMenuChoices
  lda #0
  sta PPUSCROLL
  sta PPUSCROLL
  jsr wait_vblank
  PositionXY 0, 10, 19
  jsr PrintSpaces
  PositionXY 0, 10, 20
  jsr PrintSpaces
  PositionXY 0, 10, 21
  jsr PrintSpaces
  PositionXY 0, 10, 22
  jsr PrintSpaces
  PositionXY 0, 10, 23
PrintSpaces:
  lda #' '
  .repeat 12
    sta PPUDATA
  .endrep
  rts
.endproc

.macro PositionPrintXY NT, XP, YP, String
  PositionXY NT, XP, YP
  jsr PutStringImmediate
  .byt String, 0
.endmacro

.proc WaitForKeyTimed
: jsr wait_vblank
  jsr ReadJoy
  dey
  beq :+
  lda keydown
  ora keydown+1
  beq :-
  lda keylast
  ora keylast+1
  bne :-
: rts

.endproc

.proc ShowCredits
  jsr wait_vblank
  lda #0
  sta PPUMASK
  jsr ClearName
  PositionPrintXY 0, 8,4,  "Big City"
  PositionPrintXY 0, 9,5,  "Sliding Blaster"

  PositionPrintXY 0, 2,8,  "Nearly everything"
  PositionPrintXY 0, 3,9,  "by NovaSquirrel"
  PositionPrintXY 0, 3,10, "(NovaSquirrel.com)"

  PositionPrintXY 0, 2,12, "Sound, trig and cursor code"
  PositionPrintXY 0, 3,13, "and some sounds by Tepples"
  PositionPrintXY 0, 3,14, "(PinEight.com)"

  PositionPrintXY 0, 2,16, "Inspiration from Ballmaster2"

  PositionPrintXY 0, 2,21, "Press anything to continue"

  lda #0
  sta PPUSCROLL
  sta PPUSCROLL
  jsr wait_vblank
  lda #BG_ON | OBJ_ON
  sta PPUMASK
  jsr WaitForKey
  jmp StartMainMenu
.endproc

.proc HelpAndConfig
  ControlType1 = 10
  ControlType2 = 11

  jsr wait_vblank
  lda #0
  sta PPUMASK
  jsr ClearName
  PositionPrintXY 0, 8,4,  "Big City"
  PositionPrintXY 0, 9,5,  "Sliding Blaster"

  PositionXY  0, 2,8
  jsr PutStringImmediate
  .byt "Ammo: ", $8a, $8b, " Heal: ", $8c, $8d, " Speed: ", $8e, $8f, 0
  PositionXY  0, 8,9
  jsr PutStringImmediate
  .byt $9a, $9b, "       ", $9c, $9d, "        ", $9e, $9f, 0

  PositionPrintXY 0, 2,11, "B/Left button: Shoot"
  PositionPrintXY 0, 2,12, "A/Right button: Boost"

  PositionPrintXY 0, 2,14, "Shoot at enemies to proceed"
  PositionPrintXY 0, 2,15, "while avoiding getting hit."
  PositionPrintXY 0, 2,16, "Press both buttons to join"
  PositionPrintXY 0, 2,17, "in as player 2."

  PositionPrintXY 0, 2,19, "Control mode (Change: A/Right)"

  PositionPrintXY 0, 2,20, "Player 1:"
  PositionPrintXY 0, 2,21, "Player 2:"

  PositionPrintXY 0, 2,23, "P2 mouse for P1 (Select):"

  PositionPrintXY 0, 2,28, "Press B/Left to continue"


  lda #KEY_A|KEY_B|KEY_SELECT
  sta keydown
Update:
  lda keydown
  ora keydown+1
  pha
  and #KEY_A
  beq :+
  PositionXY  0, 11,20
  ldx #0
  jsr FindSchemeIndex
  jsr PrintSchemeName

  PositionXY  0, 11,21
  ldx #1
  jsr FindSchemeIndex
  jsr PrintSchemeName
:
  pla 
  and #KEY_SELECT
  beq :+
  PositionXY  0, 28,23
  ldx ControllerSwap
  lda NoYesTable,x
  sta PPUDATA
:

  lda #0
  sta PPUSCROLL
  sta PPUSCROLL
  jsr wait_vblank
  lda #BG_ON | OBJ_ON
  sta PPUMASK

WaitMore:
  jsr wait_vblank
  jsr ReadJoy
  lda keynew+0
  ora keynew+1
  sta 1
  beq WaitMore
  and #KEY_SELECT
  beq :+
    lda ControllerSwap
    eor #1
    sta ControllerSwap
    jmp Update
  :

  ldx #0
  jsr TrySchemeChange
  ldx #1
  jsr TrySchemeChange

  lda keydown+0
  ora keydown+1
  sta 0
  and #KEY_A
  beq :+
    jsr wait_vblank
    jmp Update
  :

  lda 0
  and #KEY_B  
  jne StartMainMenu

  jmp WaitMore

TrySchemeChange:
  lda keydown,x
  and #KEY_A
  beq @Exit
  lda mouseEnabled,x
  bne @Mouse
  lda RacecarMode,x
  eor #1
  sta RacecarMode,x
  rts
@Mouse:
  inc MouseSensitivity,x
  lda MouseSensitivity,x
  cmp #3
  bne @Exit
  lda #0
  sta MouseSensitivity,x
@Exit:
  rts

PrintSchemeName:
  stx 1
  asl ; *2
  sta 0
  asl ; *4
  asl ; *8
  add 0
  tay
  ldx #10
: lda ControlSchemes,y
  sta PPUDATA
  iny
  dex
  bne :-
  ldx 1
  rts

FindSchemeIndex:
  lda mouseEnabled,x
  bne @Mouse
  lda RacecarMode,x
  rts
@Mouse:
  lda #0
  sta RacecarMode,x
  lda MouseSensitivity,x
  add #2
  rts

ControlSchemes:
  .byt "Cursor    "
  .byt "Spinning  "
  .byt "Mouse Fast"
  .byt "Mouse Med."
  .byt "Mouse Slow"
NoYesTable:
  .byt "NY"

.endproc
